var FSO = new ActiveXObject('Scripting.FileSystemObject');

function ttml_to_txt(ttml) {
  var ttml_lines = ttml.match(/<p begin="([^"]+)"[^>]*>([^<]*)<\/p>/g);
  for (var i = 0; i < ttml_lines.length; ++ i) {
    ttml_lines[i] = ttml_lines[i].replace(/<p begin="([^"]+)"[^>]*>([^<]*)<\/p>/, function (match, time, text) {
      return time + ' ' + text.replace(/&#39;/g, "'").replace(/&amp;/g, '&');
    });
  }
  return ttml_lines.join('\n');
}

if (WScript.arguments.length == 1) {
  var folder_name = WScript.arguments(0);
  if (FSO.FolderExists(folder_name)) {
    var folder = FSO.GetFolder(folder_name);
    var files = new Enumerator(folder.Files);
    
    for (var filename; !files.atEnd(); files.moveNext()) {
      filename = files.item().name;
      var txt_filename = filename.replace(/\.ttml$/i, '.txt');
      if (/\.ttml$/i.test(filename) && !FSO.FileExists(txt_filename)) {
        var file = FSO.OpenTextFile(filename);
        var ttml = file.ReadAll();
        file.Close();
        
        var txt = ttml_to_txt(ttml);
        file = FSO.CreateTextFile(txt_filename, false);
        file.Write(txt);
        file.Close();
      }
    }
  }
}